unit USample;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.TMSBaseControl, FMX.TMSGridCell, FMX.TMSGridOptions, FMX.TMSGridData,
  FMX.TMSCustomGrid, FMX.TMSGrid, FMX.StdCtrls;

type
  TTMSFMXGridCellCombined = class(TTMSFMXCheckGridCell)
  private
    FLabel: TLabel;
  public
    constructor Create(AOwner: TComponent); override;
    function GetTextRect: TRectF; override;
    function lbl: TLabel;
  end;

  TForm158 = class(TForm)
    TMSFMXGrid1: TTMSFMXGrid;
    procedure FormCreate(Sender: TObject);
    procedure TMSFMXGrid1GetCellClass(Sender: TObject; ACol, ARow: Integer;
      var CellClassType: TFmxObjectClass);
    procedure TMSFMXGrid1GetCellProperties(Sender: TObject; ACol, ARow: Integer;
      Cell: TFmxObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form158: TForm158;

implementation

{$R *.fmx}

procedure TForm158.FormCreate(Sender: TObject);
begin
  TMSFMXGrid1.BeginUpdate;
  TMSFMXGrid1.ColumnCount := 2;
  TMSFMXGrid1.RowCount := 10;
  TMSFMXGrid1.ColumnWidths[1] := 150;
  TMSFMXGrid1.EndUpdate;
end;

procedure TForm158.TMSFMXGrid1GetCellClass(Sender: TObject; ACol, ARow: Integer;
  var CellClassType: TFmxObjectClass);
begin
  if (ACol = 1) and (ARow > 0) then
    CellClassType := TTMSFMXGridCellCombined;
end;

procedure TForm158.TMSFMXGrid1GetCellProperties(Sender: TObject; ACol,
  ARow: Integer; Cell: TFmxObject);
begin
  if (Cell is TTMSFMXGridCellCombined) then
    (Cell as TTMSFMXGridCellCombined).lbl.Text := inttostr(Acol) + ':'+inttostr(ARow);
end;

{ TTMSFMXGridCellCombined }

constructor TTMSFMXGridCellCombined.Create(AOwner: TComponent);
begin
  inherited;
  CheckBox.Align := TAlignLayout.Right;
  FLabel := TLabel.Create(Self);
  FLabel.Margins.Left := 2;
  FLabel.Margins.Top := 2;
  FLabel.Margins.Right := 2;
  FLabel.Margins.Bottom := 2;
  FLabel.Parent := Self;
  FLabel.Align := TAlignLayout.Left;
  FLabel.AutoSize := True;
end;

function TTMSFMXGridCellCombined.GetTextRect: TRectF;
begin
  Result := inherited GetTextRect;
  Result.Left := Result.Left + FLabel.Width + FLabel.Margins.Left + FLabel.Margins.Right;
end;

function TTMSFMXGridCellCombined.lbl: TLabel;
begin
  Result := FLabel;
end;

end.
